<?php

//File read & File write //

function bny_readfile($file){
	require_once(ABSPATH . 'wp-admin/includes/file.php');
	$buf = '';
	if (is_file($file) === true){
		if(WP_Filesystem()){
			global $wp_filesystem;
			$buf = $wp_filesystem->get_contents($file);
		}
	}
	return $buf;
}

function bny_writefile($file, $text){
	require_once(ABSPATH . 'wp-admin/includes/file.php');
	if(WP_Filesystem()){
		global $wp_filesystem;
		$wp_filesystem->put_contents($file, $text);
	}
}



//Execute CSS minimization script when logging out //

function mincss($c){
    $c = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $c);
    $c = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $c);
    $c = str_replace(': ', ':', $c);
    return $c;
}

function exec_css_minimization() {
	$maincss = get_template_directory() . '/style.min.css';
	$ampcss = get_template_directory() . '/amp/style.php';
	$buf = "";
	ob_start();
	get_template_part("style");
	$buf = ob_get_clean();
	$buf = mincss($buf);
	bny_writefile($maincss, $buf);
	bny_writefile($ampcss, $buf);
}



// Output sidebar file //

function bny_read_sidebar($idx) {
	$buf = "";
	ob_start();
	dynamic_sidebar($idx);
	$buf = ob_get_clean();
	return $buf;
}


function bny_static_sidebar($idx) {
	$id = 'sidebar-' . $idx;
	if (!is_active_sidebar($id)){
		return;
	}
	$outfile = get_template_directory() . '/sidebar-static.php';
	$buf  = '<aside id="bny-secondary" class="widget-area">';
	$buf .= bny_read_sidebar($idx);
	$buf .= '</aside><!-- #secondary -->';
	bny_writefile($outfile, $buf);
}




//------------------sidebar for amp----------------------------------------------



// Replacing Recent Posts Widget
function bny_replace_recent_posts($content) {

	//Number of Posts to Show  - Recent Posts Widget -
	$recent_num = 10;
	if (get_option('widget_recent-posts') !== false){
		$s = get_option('widget_recent-posts');
		foreach($s as $k => $v) {
			foreach($v as $key => $value) {
				if ($key == 'number') {
					$recent_num = $value;
				}
			}
		}
	}
	$rest_uri = get_site_url() . '/wp-json/wp/v2/posts?per_page=' . $recent_num;
	$listheight = $recent_num * 60;  //Please adjust the height of one item in the list.

	$amplist = <<< EOF
		<amp-list width="auto" height="{$listheight}" layout="fixed-height" src="{$rest_uri}" items=".">
			<template type="amp-mustache">
				<div>
					<a href="{{link}}">{{title.rendered}}</a>
				</div>
			</template>
		</amp-list>
EOF;

	$content = str_replace('<amp-list></amp-list>', $amplist, $content);
	return $content;
}



// amp comverter
function bny_amp_tag_conv($content) {

	$buf  = '<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /></head><body>';
	$buf .= $content;
	$dom = new DOMDocument();
	@$dom->loadHTML($buf, LIBXML_HTML_NODEFDTD | LIBXML_NOERROR);

	//delete recent entry for REST API
	if (get_theme_mod('ck_amp_list', false)) {
		foreach ($dom->getElementsByTagName('section') as $node) {
			if (strpos($node->getAttribute('class'), 'widget_recent_entries') !== false){
				$newEle = $dom->createElement('amp-list' , '');
				$node->appendChild($newEle);
				foreach ($node->getElementsByTagName('ul') as $ulnode) {
					$ulnode->parentNode->removeChild($ulnode);
				}
			}
		}
	}

	//delete attributes
	foreach ($dom->getElementsByTagName('*') as $node) {
		$node->removeAttribute('style');
		$node->removeAttribute('target');
		$node->removeAttribute('onclick');
	}

	//convert tags    <img>, <iframe>
	$arrtags = array('img', 'iframe', 'video', 'audio');
	foreach ($arrtags as $convtag) {
		foreach ($dom->getElementsByTagName($convtag) as $node) {
			$newtag = 'amp-' . $convtag;
			$newEle = $dom->createElement($newtag , '');
			$node->parentNode->appendChild($newEle);
			foreach ($node->attributes as $nodeattr) {
				$newEle->setAttribute($nodeattr->nodeName, $nodeattr->nodeValue);
			}
			$node->parentNode->removeChild($node);
		}
	}

    //remove some tags.
	$convtags = array('script', 'style', 'base', 'frame', 'frameset', 'object', 'param', 'applet', 'embed');
	foreach ($convtags as $convtag) {
		foreach ($dom->getElementsByTagName($convtag) as $node) {
			$node->parentNode->removeChild($node);
		}
	}

	//adding target to form
    foreach ($dom->getElementsByTagName('form') as $node) {
        $node->setAttribute('target', '_top');
    }

	//output
	$buf = preg_replace('/^\<html\>.*?\<body\>/', '', $dom->saveHTML());
	$buf = preg_replace('/\<\/body\>.*?\<\/html\>\n/', '', $buf);
	if (get_theme_mod('ck_amp_list', false)) {
		$buf = bny_replace_recent_posts($buf);
	}
	return $buf;
}



//amp static sidebar
function bny_amp_static_sidebar($idx) {
    $id = 'sidebar-' . $idx;
    if (!is_active_sidebar($id)){
        return;
    }
    $outfile = get_template_directory() . '/amp/sidebar-amp.php';
    $buf  = '<aside id="bny-secondary" class="widget-area">';
    $buf .= bny_amp_tag_conv(bny_read_sidebar($idx));
    $buf .= '</aside><!-- #secondary -->';
    bny_writefile($outfile, $buf);
}

?>
